/*
 *	Dashboard Example 3.mq4
 *
 *	Just draws dashboard information on screen
 *
 *	Copyright 2013-2020, Novateq Pty Ltd
 *	https://www.orchardforex.com
 *
 */
 
#property	copyright		"Copyright 2013-2020, Novateq Pty Ltd"
#property	link				"https://www.orchardforex.com"
#property	version			"1.00"
#property	description		"Draws stuff on screen"
#property	strict

#property indicator_separate_window					//	Creates the new window

#include		<Orchard/OOP/OOP6/DashboardV3.mqh>

CDashboardV3	*Dashboard;
string		SymbolList[];
string		IndicatorName;

//---global variables
double equity_prst;
double equity_prv;

//---overall account drawdown
double present_ov_dd;
double prev_ov_dd;

//---max drawdown per pair
double pair_prst_dd;
double pair_prev_dd;

//---lowest margin % level
double lw_prst_mgn;
double lw_prev_mgn;
double margin_level;

//---Day variables
int current_day;
datetime present_day;

//---Arrays for margin values
double margin_vals[2];


int OnInit() {

   margin_level  = AccountInfoDouble(ACCOUNT_MARGIN_LEVEL);
   
	IndicatorName	=	IntegerToString(TimeCurrent());
	IndicatorShortName(IndicatorName);
	StringSplit("Margin Levels, Drawdown Levels, Pair Drawdown, Lowest Drawdown_pair", StringGetCharacter(",",0), SymbolList);
	int	columns	=	ArraySize(SymbolList);
	Dashboard		=	new CDashboardV3("test", IndicatorName, columns, 2, 15);
	UpdateDashboard();
	
   return(0);

}

void OnDeinit(const int reason) {
   
	delete	Dashboard;

   return;

}

int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]) {

	 UpdateDashboard();
	 get_margin_prst();
    get_prev_max_ov_dd();
    get_prst_max_ov_dd();
    prst_max_dd_pair();
    prev_max_dd_pair();
	
   return(rates_total);

}

void OnChartEvent(const int id,const long& lparam,const double& dparam,const string& sparam) {
        
        Dashboard.ReDraw();

}

void	UpdateDashboard() {
   //string title = "Account";
   
	for (int i = 0; i<ArraySize(SymbolList); i++) {
	
		string	symbol	=	SymbolList[i];
		

		//	The symbol
		Dashboard.Column(i).SetRow(0, symbol, clrBlue, "Verdana Bold", 12);
		Dashboard.Column(0).SetRow(2, "Current day:  " + DoubleToString(get_margin_prst(), 4) , clrGreenYellow, "Verdana Bold", 10);
		Dashboard.Column(0).SetRow(5, "Previous day: " + DoubleToString(arrs(), 4), clrGreenYellow, "Verdana Bold", 10);

		Dashboard.Column(1).SetRow(2, "Current day: " + DoubleToString(get_prst_max_ov_dd(), 4), clrGreenYellow, "Verdana Bold", 10);
		Dashboard.Column(1).SetRow(5, "Previous day: " + DoubleToString(get_prev_max_ov_dd(), 4), clrGreenYellow, "Verdana Bold", 10);

		Dashboard.Column(2).SetRow(2, "Current day: " + DoubleToStr(prst_max_dd_pair(), 4), clrGreenYellow, "Verdana Bold", 10);
		Dashboard.Column(2).SetRow(5, "Previous day: " + DoubleToString(prev_max_dd_pair(), 4), clrGreenYellow, "Verdana Bold", 10);
		
		Dashboard.Column(3).SetRow(2, "Current day: ", clrGreenYellow, "Verdana Bold", 10);
		Dashboard.Column(3).SetRow(5, "Previous day: ", clrGreenYellow, "Verdana Bold", 10);				
		}
		
		//Account lowest margin levels prev and present
		//Account max dd prst and prev
		
		//Account dd//selected_pair on chart
		
		//Symbol with lowest dd
		
		
		
		
	

	return;
	
}


//================================Overall  account drawdown====================================
//---get the overall account drawdown

double get_prst_max_ov_dd()
   {
   equity_prst = AccountInfoDouble(ACCOUNT_EQUITY);
   current_day = Day();
   present_ov_dd = equity_prst;
   datetime day_start = iTime(NULL, PERIOD_D1, 0);
   datetime day_end = day_start + PeriodSeconds(PERIOD_D1);
   double negative_dd ;
   if(TimeCurrent()== day_start)
      {
      negative_dd =0;
      if()
      }
      
      return negative_dd;
   }
   
double get_prev_max_ov_dd() 
   {
   for(int i = 0; i < OrdersTotal();i++)
      {
      if(OrderSelect(i, SELECT_BY_POS, MODE_HISTORY))
         {
         if(OrderOpenTime() >= (TimeCurrent() - (60*60*24)) && OrderOpenTime() < TimeCurrent() )
            {
            if(OrderProfit() < 0)
               {
               prev_ov_dd += OrderProfit();
               }
            }
         }
      }
      return prev_ov_dd;
   }  
   
//================================Max Drawdown per pair=========================================
//---get the max drawdown per pair 

double prst_max_dd_pair()
   {
   for(int i = 0;i < OrdersTotal();i++)
      {
      if(OrderSelect(i, SELECT_BY_POS, MODE_HISTORY))
         {
         if(OrderSymbol() == _Symbol)
            {
            if(OrderProfit() < 0)
               {
               pair_prst_dd += OrderProfit(); 
               }
            }
         }
      }
      return pair_prst_dd;
   }

double prev_max_dd_pair()
   {
   for(int i = 0;i < OrdersTotal();i++)
      {
      if(OrderSelect(i, SELECT_BY_POS, MODE_HISTORY))
         {
         if(OrderOpenTime() >= (TimeCurrent() - (60*60*24)) && OrderOpenTime() < TimeCurrent())
            {
            if(OrderSymbol() == _Symbol)
               {
               if(OrderProfit() < 0)
                  {
                  pair_prev_dd += OrderProfit();
                  }
               }
            }
         }
      }
      return pair_prev_dd;
   }





//=================================lowest margin level % per trading day=========================
//---get the lowest margin level reached per day


double get_margin_prst()
   {
   current_day = Day();
   double low_touch = 0;
   margin_level = AccountInfoDouble(ACCOUNT_MARGIN_LEVEL);
   datetime day_start = iTime(NULL, PERIOD_D1, 0);
   datetime day_end = day_start + PeriodSeconds(PERIOD_D1);
   double comp_st_mgn = get_mgn_day_start();
   
   if(TimeCurrent() >= day_start && TimeCurrent() < day_end)
      {
      margin_vals[0] = margin_level;
      //if(margin_level < margin_vals[0])
      //   {
      //   margin_vals[0]= margin_level;
      //   }
      }

   
      return margin_vals[0];
   }


double get_mgn_day_start() 
   {
   margin_level = AccountInfoDouble(ACCOUNT_MARGIN_LEVEL);
   datetime day_start = iTime(NULL, PERIOD_D1, 0);
   datetime day_end = day_start + PeriodSeconds(PERIOD_D1);
   double start_margin = 0;
   if(TimeCurrent() == day_start)
      {
      start_margin = margin_level;
      }   
      return start_margin;
   }
   
   
double arrs() 
   {
// Declare an array to store the margin level values
double marginLevels[];
int currentIndex = 0;

// Get the number of minutes
int minutes = 10;

// Iterate for the number of minutes
for (int i = 0; i < minutes; i++)
{
    // Get the current margin level
    double marginLevel = AccountInfoDouble(ACCOUNT_MARGIN_LEVEL);
    //store the margin level in the array
    ArrayResize(marginLevels, currentIndex+1);
    marginLevels[currentIndex] = marginLevel;
    currentIndex++;
    // Sleep for 1 minute
    Sleep(60000);
}

// Print the margin level values for each minute
for (int i = 0; i < ArraySize(marginLevels); i++)
{
    Print("Margin level on minute ", i+1, ": ", marginLevels[i]);
}   

return marginLevels[0];
   }  
